/// <reference types="node" />
import EventEmitter from 'events';
import { Configuration as WebpackConfig, Stats } from 'webpack';
import { MochapackOptions } from '../cli/argsParser/optionsFromParsedArgs/types';
declare type MochaRunner = {
    abort: () => void;
    currentRunnable?: {
        retries: (count: number) => void;
        enableTimeouts: (enabled: boolean) => void;
        timeout: (ms: number) => void;
        resetTimeout: (ms: number) => void;
    };
};
declare type Mocha = {
    run: (cb: (failures: number) => void) => MochaRunner;
};
export default class TestRunner extends EventEmitter {
    entries: Array<string>;
    includes: Array<string>;
    options: MochapackOptions;
    cwd: string;
    constructor(entries: Array<string>, includes: Array<string>, options: MochapackOptions, cwd: string);
    prepareMocha(webpackConfig: WebpackConfig, stats: Stats): Mocha;
    run(): Promise<number>;
    watch(): Promise<void>;
    private createWebpackConfig;
}
export {};
